<template>
  <div class="card-table">
    <div class="wp-field--notify" v-if="isDataEmpty">
      {{ $props.options.noDataText || 'Нет данных для отображения' }}
    </div>
    <div class="wp-12 card-table__list" :class="{
      'card-table__list--opened': isOpened,
    }" v-else>
      <div class="wp-12 list-title">
        <div class="title-index">
          {{ $props.index.title }}
        </div>
        <div class="title-columns">
          <div class="title-column" v-for="columnDef in $props.columnsDefs"
            :key="(columnDef.name || columnDef.prop)">
            {{ columnDef.title }}
          </div>
        </div>
        <div class="title-action" v-if="$props.options.spoiler" @click="changeState">
          <font-awesome-icon class="title-action__icon" icon="angle-down" size="sm"/>
        </div>
      </div>
      <div class="list-content">
        <div class="list-content__row" v-for="(row, rowIndex) in $props.data" :key="rowIndex">
          <slot name="index" :row="row">
            <div class="row-index">
              {{ row[$props.index.prop] }}
            </div>
          </slot>
          <div class="row-columns">
            <div class="row-column" v-for="(columnDef, columnIndex) in $props.columnsDefs"
              :key="`${rowIndex}-${columnIndex}`">
              <slot :name="(columnDef.name || columnDef.prop)" :row="row">
                {{ row[columnDef.prop] }}
              </slot>
            </div>
          </div>
          <div class="row-action" @click="onRowActionClick(row)">
            <slot name="action" :row="row">
              <font-awesome-icon class="row-action__icon" v-if="$props.options.action"
                :icon="$props.options.action.icon"/>
            </slot>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: 'CardTable',
  props: {
    options: {
      type: Object,
      default: () => {},
    },
    index: {
      type: Object,
      required: true,
    },
    columnsDefs: {
      type: Array,
      required: true,
    },
    data: {
      type: Array,
      required: true,
    },
  },
  data() {
    return {
      isOpened: false,
    };
  },
  computed: {
    isDataEmpty() {
      return this.$props.data.length === 0;
    },
  },
  methods: {
    changeState() {
      this.isOpened = !this.isOpened;
    },
    onRowActionClick(row) {
      this.$emit('action', row);
    },
  },
  mounted() {
    if (!this.$props.options.spoiler) this.changeState();
  },
};
</script>

<style lang="scss" scoped>
.card-table {
  margin-bottom: 15px;

  &__list {
    margin-bottom: 10px;

    .list {

      &-title {
        margin-bottom: 4px;
        display: flex;
        align-items: center;
        font-size: 14px;
        font-family: $firaSans;
        color: $neutralDarker;

        .title {

          &-columns {
            margin-left: auto;
            margin-right: 20px;
          }

          &-column {
            font-size: 14px;

            &:not(:last-child) {
              margin-right: 5px;
            }

          }

          &-action {
            height: 15px;
            width: 15px;
            display: flex;
            justify-content: center;
            align-items: center;

            &__icon {
              margin-top: 1px;
              color: $neutralDarker;
              transition: transform ease-in-out .2s;
            }

          }

        }

      }

      &-content {
        max-height: 0;

        &__row {
          margin-bottom: 3px;
          display: flex;
          align-items: center;
          font-size: 16px;
          font-family: $roboto;

          .row {

            &-columns {
              margin-left: auto;
              margin-right: 5px;
              display: flex;
              justify-content: flex-end;
              align-items: center;
            }

            &-column {

              &:not(:last-child) {
                margin-right: 5px;
              }

            }

            &-action {
              height: 15px;
              width: 15px;
              display: flex;
              justify-content: center;
              align-items: center;

              &__icon {
                margin-bottom: 1px;
                height: 12px;
                color: $neutralDark;
                transition: color ease-in-out .2s;
              }

              &:hover {
                cursor: pointer;

                .row-action__icon {
                  color: $primary;
                }

              }

            }

          }

        }

      }

    }

    &--opened {

      .list {

        &-title > .title-action__icon {
          transform: rotateZ(180deg);
        }

        &-content {
          max-height: unset;
        }

      }

    }

  }

}
</style>
